require File.expand_path(File.dirname(__FILE__) + '/../../spec_helper')
require 'webmock/rspec'

describe "A HEL Resource" do
  def req_url(site, path)
    uri = URI(site.to_s)
    uri.path = path
    uri.to_s
  end

  def stub_requests
    stub_request(:post, req_url(ActiveResource::Hel::Resource.site, "/ygg/session/authenticate_by_fqda_and_password")).
      with(
        body: {fqda: ActiveResource::Hel::Resource.hel_identity, password: ActiveResource::Hel::Resource.hel_secret}
    ).to_return(
	    status: 200,
      body: {
        "id":"089af4a6-d558-40f1-86c4-c4ca3bf03815",
        "authenticated":true,
        "status":"authenticated",
        "started_at":"2019-09-21T10:15:54.000+02:00",
        "auth_credential":"Ygg::Core::Identity::Credential::ObfuscatedPassword",
        "auth_identity": ActiveResource::Hel::Resource.hel_identity,
        "auth_method":"fqda_and_password",
        "auth_confidence":"medium",
        "capabilities":["superuser","full_interface","simple_interface","api","installer"],
        "active":true,
        "msg":"Auhtentication successful!",
        "reason":"ok"
      }.to_json
    )

    stub_request(:get, req_url(ActiveResource::Hel::Resource.site, "/ygg/core/identities/#{ActiveResource::Hel::Resource.hel_identity}")).
      with(headers: {
        'Authorization'=>'Bearer 089af4a6-d558-40f1-86c4-c4ca3bf03815',
      }).
      to_return(status: 200, body: {
        qualified: ActiveResource::Hel::Resource.hel_identity
      }.to_json, headers: {})
  end

  it 'should authenticate a request' do
    stub_requests
    Ygg::Core::Identity.cached = false
    identity = ActiveResource::Hel::Resource.hel_identity

    i = Ygg::Core::Identity.find_by_qualified(identity)
    expect(i.qualified).to eq identity

    i = Ygg::Core::Identity.find_by_qualified(identity)

    connection =  Ygg::Core::Identity.connection
    expect(connection.session).to be_authenticated
    expect(connection.session.identity).to eq identity

  end
end
